/***************************************************************************
                          main.cpp  -  description                              
                             -------------------                                         
    begin                : Tue Aug 17 11:54:44 CDT 1999
                                           
    copyright            : (C) 1999 by Joe Nelson                         
    email                : 3nelsons@pressenter.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "easyaddress.h"
#include "easyneterror.h"
#include "easysocket.h"
#include "easyserver.h"
#include <iostream>
#include <string>
#include <stdlib.h>
using namespace std;

int main(void){
try
{
	cout << "What port do you want this server to squat on? ";
	unsigned short port;
	cin >> port;

	EasyServer svr(port);
	cout << "Server name: " << svr.WhoAmI().Name() << endl;
	cout << "Awaiting a client...";
	cout.flush();

	EasySocket client = svr.AwaitConnection();
	cout << "Connection is made. Client is " << client.ConnectedTo().Name() << endl;
	client.Write("Hello, this is a silly server. Enter a line of text!\n\r");
	cout << "Watch a line of text as it comes in!\n";

	string buf;
	while(buf[0] != '\n' && buf[0] != '\r')  // get a line of text terminted by either \n or \r
	{
		client.Read(buf, 1);
		cout << buf;
		cout.flush();
	}
	cout << endl;
}
catch(EasyNetError &e)
{
	cerr << "An exception occurred in " << e.where() << endl;
	cerr << "Description: " << e.what() << endl;
	cerr << "Error num: " << e.errornum() << endl;
	return EXIT_SUCCESS;
}

	return EXIT_SUCCESS;
}
