/***************************************************************************
                          ezserver.cpp  -  description                              
                             -------------------                                         
    begin                : Fri Aug 20 1999                                           
    copyright            : (C) 1999 by Joe Nelson                         
    email                : 3nelsons@pressenter.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "easyserver.h"

EasyServer::EasyServer(unsigned short port) throw(EasyNetError) {
	_onPort = port;
	char temp[256];
	gethostname(temp, 256);
	_myAddress = new EasyAddress(string(temp));
}

EasyServer::~EasyServer() throw() {
	delete _myAddress;
}

/** Wait for, and return, client connection */
EasySocket EasyServer::AwaitConnection() throw(EasyNetError) {
	int listenSocket = socket(PF_INET, SOCK_STREAM, 0);
	if(listenSocket == -1)
		throw(EasyNetError(errno, "EasyServer::AwaitConnection()", "socket()"));

	struct sockaddr_in svrInfo, remoteInfo;
	svrInfo.sin_family      = PF_INET;
	svrInfo.sin_port        = htons(_onPort);
	svrInfo.sin_addr.s_addr = INADDR_ANY;

	if(bind(listenSocket, (struct sockaddr*)&svrInfo, sizeof(struct sockaddr)) == -1)
	{
		shutdown(listenSocket, 2);
		throw(EasyNetError(errno, "EasyServer::AwaitConnection()", "bind()"));
	}

	if(listen(listenSocket, SOMAXCONN) == -1)
	{
		shutdown(listenSocket, 2);
		throw(EasyNetError(errno, "EasyServer::AwaitConnection()", "listen()"));
	}

	unsigned int tempSize = sizeof(struct sockaddr);
	int remoteSocket = accept(listenSocket, (struct sockaddr*)&remoteInfo, &tempSize);
	if(remoteSocket == -1)
	{
		shutdown(listenSocket, 2);
		throw(EasyNetError(errno, "EasyServer::AwaitConnection()", "accept()"));
	}

	shutdown(listenSocket, 2);
	return EasySocket(remoteSocket);
}

/** Returns the local address that the server is listening on.*/
EasyAddress EasyServer::WhoAmI() const throw() {
	return *_myAddress;
}
